#include <stdio.h>
#include <algorithm>
#pragma comment(linker, "/stack:32000000")
const char start = 'S';
const char finish = 'F';
const char wall = '#';
const char pepelatc = 'P';
const int MaxWH = 150*1000;
const int MaxE = 10*1000;
const int INF = 100*1000*1000;
const int MaxPl = 10;
char map[MaxWH+1], c;
int dist[MaxPl+3][MaxPl+3], move[4] = {-1, 0, 1, 0}, list[MaxPl+3];
int queue[MaxWH+1], qr, qw, road[MaxWH+1], perm[MaxPl+3], link[MaxWH+1];
int i, j, k, l, n, m, t, tmp, tmpm, ans, tmpans, p, e, tmpcol, tmprow;
bool vis[MaxPl+3];                                
struct{
  int from, to;
}edge[MaxE+1];
FILE *fi, *fo;

void QSort(int l, int r){
  int x = edge[rand()%(r-l)+l].from, i = l, j = r;
  do{
    while(edge[i].from < x) i++;
    while(edge[j].from > x) j--;
    if(i <= j){
      std::swap(edge[i++], edge[j--]);
    }
  }while(i <= j);
  if(l < j) QSort(l, j);
  if(i < r) QSort(i, r);
}

void dfs(int s){
  int t;
  int i = link[s];
  while(i != -1){
    t = edge[i++].to;
    if(road[t] == -1){
      queue[qw++] = t;
      road[t] = road[s];
      dfs(t);
    }
    if(edge[i-1].from != edge[i].from) break;
  }
}

void bfs(int &s){
  int t;
  memset(road, 255, sizeof(road));
  road[list[s]] = 0;
  qw = qr = 0;
  queue[qw++] = list[s];
  dfs(list[s]);
  do{
    tmp = queue[qr]; 
    for(t = 0; t <= 3; t++){
      tmpm = tmp + move[t];
      if(tmpm >= 1 && tmpm <= n*m && map[tmpm] != wall && road[tmpm] == -1){
        if(t%2 == 0 && (tmp-1)/m != (tmpm-1)/m) continue;
        road[tmpm] = road[tmp] + 1;
        queue[qw++] = tmpm;
        dfs(tmpm);
      }
    }
    qr++;
  }while(qr < qw);
  for(t = 1; t <= k+2; t++){
    dist[s][t] = road[list[t]];
    if(dist[s][t] == -1)dist[s][t] = INF;
  }
}

void rec(int s, int x){
  int t;
  if(p == k){
    tmpans += dist[s][k+2];
    if(tmpans < ans) ans = tmpans;
    tmpans -= dist[s][k+2];
    return;
  }
  for(t = 2; t <= k+1; t++){
    if(!vis[t]){
      vis[t] = true; tmpans += dist[s][t]; p++;
      rec(t, s);                        
      p--; tmpans -= dist[s][t]; vis[t] = false;
    }
  }
}

int main(){
  srand(12345678);
  list[0] = 2;
  fi = fopen("input.txt", "r");
  fo = fopen("output.txt", "w");
  fscanf(fi, "%i%i%i", &n, &m, &k); move[1] = -m; move[3] = m;
  for(i = 1; i <= n*m; i += (map[i] >= 32 && map[i] <= 127)){
    fscanf(fi, "%c", &map[i]);
    switch(map[i]){
      case start : list[1] = i; break;
      case finish: list[k+2] = i; break;
      case pepelatc: list[list[0]++] = i; break;
    }
  }
  fscanf(fi, "%i", &e);
  for(i = 1; i <= e; i++){
    fscanf(fi, "%i%i", &tmprow, &tmpcol);
    edge[i].from = (tmprow-1)*m + tmpcol;
    fscanf(fi, "%i%i", &tmprow, &tmpcol);
    edge[i].to = (tmprow-1)*m + tmpcol;
  }
  if(e > 1) QSort(1, e);
  memset(link, 255, sizeof(link));
  for(i = 1; i <= e; i++){
    if(edge[i-1].from != edge[i].from) link[edge[i].from] = i;
  }
  for(i = 1; i <= k+2; i++){
    bfs(i);
  }
  ans = INF; tmpans = 0;
  perm[1] = list[1]; perm[k+2] = list[k+2];
  memset(vis, false, sizeof(vis));
  p = 1;
  for(t = 2; t <= k+1; t++){
    vis[t] = true;
    tmpans = dist[1][t];
    rec(t, 1);
    vis[t] = false;
  }
  if(k == 0) ans = dist[1][2];
  if(ans == INF) fprintf(fo, "-1"); else fprintf(fo, "%i", ans);
  fclose(fi);
  fclose(fo);
  return 0;
}