{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 32000000}

uses SysUtils, Math;

const start = 'S';
      finish = 'F';
      wall = '#';
      pepelatc = 'P';
      MaxWH = 150*1000;
      MaxE = 10*1000;
      INF = 100*1000*1000;
      MaxPl = 10;

var map: array[0..MaxWH+1] of char;
    c: char;
    dist: array[0..MaxPl+3, 0..MaxPl+3] of integer;
    move: array[0..3] of integer;
    list: array[0..MaxPl+3] of integer;
    queue, road, link: array[0..MaxWH+1] of integer;
    perm: array[0..MaxPl+3] of integer;
    vis: array[0..MaxPl+3] of boolean;
    i, j, k, l, n, m, t, tmp, tmpm, ans, tmpans, p, e, tmpcol, tmprow: integer;
    qr, qw, tt: integer;
    edge: array[0..MaxE+1] of record _from, _to: integer; end;
    fi, fo: text;

procedure swap(var a, b: integer);
  begin
    tt := a; a := b; b := tt;
  end;

procedure QSort(l, r: integer);
var x, i, j: integer;
begin
  x := edge[random(r-l)+l]._from; i := l; j := r;
  repeat
    while edge[i]._from < x do inc(i);
    while edge[j]._from > x do dec(j);
    if i <= j then
     begin
       swap(edge[i]._from, edge[j]._from);
       swap(edge[i]._to, edge[j]._to);
       inc(i); dec(j);
     end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

procedure dfs(s: integer);
var i, t: integer;
begin
  i := link[s];
  while i <> -1 do
    begin
      t := edge[i]._to; inc(i);
      if road[t] = -1 then
        begin
          queue[qw] := t; inc(qw);
          road[t] := road[s];
          dfs(t);
        end;
      if edge[i-1]._from <> edge[i]._from then break;
    end;
end;

procedure bfs(var s: integer);
var t: integer;
begin
  FillChar(road, SizeOf(road), 255);
  road[list[s]] := 0;
  qw := 0; qr := 0;
  queue[qw] := list[s]; inc(qw);
  dfs(list[s]);
  repeat
    tmp := queue[qr];
    for t := 0 to 3 do
      begin
        tmpm := tmp + move[t];
        if (tmpm >= 1) and (tmpm <= n*m) and (map[tmpm] <> wall) and (road[tmpm] = -1) then
          begin
            if (t mod 2 = 0) and ((tmp-1) div m <> (tmpm-1) div m) then continue;
            road[tmpm] := road[tmp] + 1;
            queue[qw] := tmpm; inc(qw); dfs(tmpm);
          end;
      end;
  inc(qr); 
  until qr >= qw;
  for t := 1 to k+2 do
    begin
      dist[s, t] := road[list[t]];
      if dist[s, t] = -1 then dist[s, t] := INF;
    end;
end;

procedure rec(s, x: integer);
var t: integer;
begin
  if p = k then
    begin
      inc(tmpans, dist[s, k+2]);
      if tmpans < ans then ans := tmpans;
      dec(tmpans, dist[s, k+2]);
      exit;
    end;
  for t := 2 to k+1 do
    begin
      if not vis[t] then
        begin
          vis[t] := true; inc(tmpans, dist[s, t]); inc(p);
          rec(t, s);
          dec(p); dec(tmpans, dist[s, t]); vis[t] := false;
        end;
    end;
end;

begin
  randomize;
  list[0] := 2;
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  read(fi, n, m, k);
  move[0] := -1; move[1] := -m; move[2] := 1; move[3] := m;
  i := 1;
  repeat
    read(fi, map[i]);
    case map[i] of
      start: list[1] := i;
      finish: list[k+2] := i;
      pepelatc:
        begin
          list[list[0]] := i;
          inc(list[0]);
        end;
    end;
    if (map[i] >= ' ') and (map[i] <= '~') then inc(i);
  until(i > n*m);
  read(fi, e);
  for i := 1 to e do
    begin
      read(fi, tmprow, tmpcol);
      edge[i]._from := (tmprow-1)*m + tmpcol;
      read(fi, tmprow, tmpcol);
      edge[i]._to := (tmprow-1)*m + tmpcol;
    end;
  if e > 1 then QSort(1, e);
  FillChar(link, SizeOf(link), 255);
  for i := 1 to e do
    if edge[i-1]._from <> edge[i]._from then link[edge[i]._from] := i;
  for i := 1 to k+2 do
    bfs(i);
  ans := INF; tmpans := 0;  
  perm[1] := list[1]; perm[k+2] := list[k+2];
  FillChar(vis, SizeOf(vis), false);
  p := 1;
  for t := 2 to k+1 do
    begin
      vis[t] := true;
      tmpans := dist[1, t];
      rec(t, 1);
      vis[t] := false;
    end;
  if k = 0 then ans := dist[1, 2];
  if ans = INF then write(fo, '-1') else write(fo, ans);
  CloseFile(fi);
  CloseFile(fo);
end.
